### 描述
	数据推送服务主要是满足客户需要设备基本数据进行二次开发的需求。该功能能够实现设备位置数据，报警数据，事件数据，离线/在线状态数据，指令下发数据的主动推送。
	1.首先需要编写一个基于POST方法的Webhook服务端接口，用来接收服务器转发过去的数据，可以参考客户端代码示例
	2.将编写好的WEBAPI地址通过规则配置——>新建规则，填入到客户端地址里面，对应的是接口的完整URL，比如：http://47.112.122.222:8080/revTerminalLocation
	3.规则配置好后，预计5分钟内将会自动生效，这时候设备上报数据，系统的推送引擎就会将数据转发至配置的客户端地址。
### 规则配置
 用户可以规则配置界面中，配置指定公司需要推送的数据，用户需要配置数据类型和客户端地址等信息
 如果有消息头限制，需要加上消息头配置，没有的话，可忽略
![](/uploads/d3R59U60qgOHqXSG/images/m_b869279a2e0c90d0f1361cc10ab28767_r.png)
![](/uploads/d3R59U60qgOHqXSG/images/m_36f296d5df222ac63b895b78539d9947_r.png)
### 数据类型说明
  #### 1.定位数据
    设备的定位数据，包括设备号，定位时间，经纬度，速度，里程等信息
  ##### JSON字符串示例
      {"assetId":"8022300001","longitude":0.0,"latitude":0.0,"speed":0,"direction":0,"mileage":16,"gpsTime":"2022-09-01T08:59:56Z",\"ksInfo\":\"null\","recvTime":"2022-09-01T08:59:56.964Z","locType":0,"cellSignal":19,"gnssSignal":0,"cells":"460,0,9383,220792647","battery":100,"voltage":"0.0","statusJson":"{\"lockBar\":-1,\"lockRope\":0,\"lockStatus\":0}","expandInfo":"{\"angle\":\"null\",\"backBattery\":\"null\",\"fuels\":\"-1,-1,-1\",\"humidity\":\"0\",\"lux\":\"0.0\",\"networkType\":\"0\",\"pressure\":\"0.0\",\"reportType\":\"0\",\"temperature\":\"-1000.0\"}"}

##### Json字段说明
  |参数名|类型|说明|
|:-----  |:-----|-----|
|assetId |String|设备号|
|longitude |Double|经度(WGS-84)|
|latitude |Double|纬度(WGS-84)|
|speed |Integer|速度(km/h)|
|direction |Integer|方向(0~360)|
|mileage |Long|里程(km)|
|gpsTime |String|定位时间（UTC时间）|
|recvTime |String|接收时间（UTC时间）|
|locType |Integer|定位类型（0：不定位；1：GPS定位；2：基站定位）|
|cellSignal |Integer| GPRS信号|
|gnssSignal |Integer|卫星信号 |
|cells |String|小区码数据，以 MNC，MCC,LAC,CID的格式显示|
|battery |Integer|电量，255表示充电中 |
|voltage |String|电压 (V)|
|statusJson |String|锁/车载状态JSON（可参考下面的状态JSON说明）|
|expandInfo |String|拓展信息JSON（可参考下面的扩展信息JSON说明）|
|ksInfo |String|KS20A设备信息JSON（可参考下面的KS20A设备信息JSON说明）,例:,"ksInfo":"{\"angVelocity\":21000.0,\"eleStatus\":0,\"eleValue\":3.48,\"humidity\":0,\"luminance1\":50,\"luminance2\":50,\"luminance3\":50,\"luminance4\":50,\"posture\":\"x:0;y:0;z:230\",\"shakeStatus\":1,\"subInfo\":{\"112408000035\":{\"dateTime\":\"2025-05-14T09:39:03Z\",\"humidity\":60.0,\"lux\":0.0,\"subId\":\"112408000035\",\"temperature\":29.3}},\"subLockId\":\"022408000000\",\"temperature\":36.0,\"vibrate\":0,\"volStatus\":0,\"volValue\":23.5}"|

##### 锁状态JSON说明
|参数名|类型|说明|
|:-----  |:-----|-----|
|lockRope |Integer|锁绳状态(1: 拔出 0:插入 -1:无）|
|lockStatus |Integer|锁状态（0：关 1：开）|

##### 车载状态JSON说明
|参数名|类型|说明|
|:-----  |:-----|-----|
|acc |Integer|引擎开关状态（ 1：开 0：关 -1：无）|
|fuelCut |Integer|断油电开关状态 (1：开 0：关 -1：无）|
|door |Integer|开关门状态（1：开 0：关 -1：无）|
|engine |Integer|发动机状态（1：开 0：关 -1：无）|

##### 拓展信息JSON说明
|参数名|类型|说明|
|:-----  |:-----|-----|
|temperature |String|温度 -1000表示无,单位℃|
|humidity |String|湿度 ,单位:%|
|fuels |String|油位值 -1表示无（"-1，-1，-1"）|
|fAcceleration |String|加速度("x:1;y:-29;z:-2903")|
|lux |float|光照度,单位:lux|
|pressure |float|气压(pa)|
|posture |String|姿态（"x:1;y:-29;z:-2903"）|
|fVoltage |Double|电压值,单位:V|
|backBattery |String|备用电池 （"55,3.88,0"）|
|fReportType |Integer|数据类型（0：实时；1:补报；2：报警）|
|fNetworkType |Integer|网络类型 （0：未知 1：1G 2：2G 3:3G 4:4G 5:5G）|

##### KS20A设备信息JSON说明
|参数名|类型|说明|
|:-----  |:-----|-----|
|temperature |double|板载温度 -1000表示无效,单位℃|
|humidity |Integer|湿度 ,单位:%|
|volStatus |Integer|电压状态（0：LED电压正常  1：LED电压过压 2:电压欠压）|
|volValue |double|电压值,单位:V|
|eleStatus |Integer|电流状态  0：LED电流正常  1：LED电流过流 2:电流欠流|
|eleValue |double|电流值,单位:A|
|pressure |float|气压(pa)|
|shakeStatus |Integer|0:静止  1：摇晃|
|angVelocity |Long|角速度,单位:mdps|
|posture |String|姿态x,y,z轴值|
|vibrate |Integer|震幅,单位:mg|
|subLockId |String|锁控制器ID|
|subLargeCharId |String|大字控制器ID|
|luminance1 |Integer|白灯亮度,单位:%|
|luminance2 |Integer|红灯亮度,单位:%|
|luminance3 |Integer|黄灯亮度,单位:%|
|luminance4 |Integer|蓝灯亮度,单位:%|
|subInfo |Map<String,Object>|外设信息,可参数值:{\"112408000042\":{\"dateTime\":\"2025-05-13T09:55:25Z\",\"humidity\":54.0,\"lux\":0.0,\"subId\":\"112408000042\",\"temperature\":28.9}}|

##### subInfo中Object说明
|参数名|类型|说明|
|:-----  |:-----|-----|
|subId |String|外设ID|
|dateTime |String|外设上线时间,UTC时间|
|temperature |double|温度,单位:℃|
|humidity |Integer|湿度,单位:%|
|lux |double|光照度,单位:lux|


  #### 2.报警数据
    设备产生的报警数据，包括设备号，报警类型，报警时间，经纬度等信息
 ##### 推送JSON示例
    {"assetId":"875011000025","alarmType":46,"dateTime":"2020-04-01T00:00:13Z","longitude":0.0,"latitude":0.0,"speed":0,"mileage":0,"cells":"0,0,0,0","describe":"","fileIndex":"1585699212"}
  ##### Json字段说明
  |参数名|类型|说明|
|:-----  |:-----|-----|
|assetId |String|设备号|
|alarmType |Integer|报警类型（可参考下面的报警类型说明）|
|dateTime |String|时间（UTC时间）|
|longitude |Double|经度(WGS-84)|
|latitude |Double|纬度(WGS-84)|
|speed |Integer|速度(km/h)|
|mileage |Long|里程(km)|
|cells |String|小区码数据，以 MNC，MCC,LAC,CID的格式显示|
|describe |String|描述|
|fileIndex |String|附件流水号|

#### 报警类型说明：

|报警类型|报警名称|
|:----   |-----   |
|1|超速报警|
|2|疲劳驾驶|
|3|危险预警|
|4|GNSS模块发生故障|
|5|GNSS天线未接或被剪断|
|6|GNSS天线短路|
|7|终端主电源欠压|
|8|终端主电源掉电|
|9|终端LCD或显示器故障|
|10|TTS模块故障|
|11|摄像头故障|
|12|道路运输证IC卡模块故障|
|13|超速预警|
|15|断电报警|
|19|超时停车|
|23|路线偏离报警|
|24|车辆VSS故障|
|26|车辆被盗|
|27|车辆非法点火|
|28|车辆非法位移|
|29|碰撞预警|
|30|侧翻预警|
|31|非法开门报警|
|32|视频信号丢失报警|
|33|视频信号遮挡报警|
|34|存储单元故障报警|
|35|其他视频设备故障报警|
|36|客车超员报警|
|37|异常驾驶行为报警|
|38|特殊报警录像达到存储阈值报警|
|40|锁绳剪断|
|41|震动|
|42|长时间开锁|
|43|开锁密码连续5次错误|
|44|刷非法卡|
|45|低电量|
|46|开后盖|
|47|卡锁|
|48|进区域报警|
|49|出区域报警|
|50|启用后备电池|
|51|SOS|
|52|拖吊报警|
|54|油位报警|
|55|进热点报警|
|56|出热点报警|
|57|进道路报警|
|58|出道路报警|
|63|温湿度报警|
|64|前向碰撞报警|
|65|车道偏离报警|
|66|车距过近报警|
|67|行人碰撞报警|
|68|频繁变道报警|
|69|道路标识超限报警|
|70|障碍物报警|
|71|道路标志识别事件|
|72|主动抓拍事件|
|73|实线变道报警|
|74|车厢过道行人监测报警|
|92|疲劳驾驶报警|
|93|接打电话报警|
|94|抽烟报警|
|95|分神驾驶报警|
|96|驾驶员异常报警|
|97|自动抓拍事件|
|98|驾驶员变更事件|
|99|探头遮挡报警|
|100|超时驾驶报警|
|101|未系安全带报警|
|102|红外阻断型墨镜失效报警|
|103|双脱把报警|
|104|玩手机报警|
|110|胎压报警|
|125|后方接近报警|
|126|左侧后方接近报警|
|127|右侧后方接近报警|
|131|急加速报警|
|132|急减速报警|
|133|急转弯报警|
|134|怠速报警|
|135|异常熄火报警|
|136|空挡滑行报警|
|137|发动机超转报警|
|141|超速报警|
|145|超过车辆额定载重报警|
|146|超过道路承重报警|
|151|限高报警|
|160|安全带报警|
|161|紧急刹车报警|
|162|空挡滑行|
|163|GPRS重连|
|164|调度屏连接|
|165|调度屏断开|
|166|CANBUS断开连接报警|
|167|CANBUS故障码上传报警|
|168|限制开车报警|
|180|主机拆卸|
|190|上盖破坏|
|191|Gps天线干扰|
|192|低电量休眠报警|
|193|锁异常|
|194|开锁密码错误|
|195|没有定位不执行开锁|
|196|围栏外禁止开锁|
|197|姿态报警|
|198|从机信号丢失|
|199|监管状态禁止开锁|
|200|主电池更换|
|201|自检异常|
|202|存储空间不足|
|203|锁条弯曲|
|204|锁条锯断|
|205|锁条丢失|
|206|施封状态禁止开锁|
|216|摇晃|
|316|光感报警|
|332|气压报警|
|400|超时怠速报警|
|402|围栏超时停留报警|
|403|出围栏未上锁报警|
|404|晚发预警|
|405|晚发报警|
|406|晚到预警|
|407|晚到报警|

 #### 3.事件数据
    设备产生的事件数据，包括设备号，事件类型，时间，经纬度等信息
   ##### 推送JSON示例
    {"assetId":"795206001104","eventType":1,"unLockType":1,"dateTime":"2022-08-19T02:07:28Z","longitude":0.0,"latitude":0.0,"speed":0,"mileage":5,"cells":"460,0,10352,220726855","card":"0003116836","password":"","describe":"{\"waybillGUID\":\"190db1a2-3df1-4857-b94e-ee5937334409\",\"waybillNo\":\"45435345\"}"}
  ##### Json字段说明
  |参数名|类型|说明|
|:-----  |:-----|-----|
|assetId |String|设备号|
|eventType |Integer|事件类型（可参考下面的事件类型说明）|
|unLockType |Integer|开锁类型，只针对开关锁事件(1:刷卡开锁 2：远程开锁 3：蓝牙开锁 4：剪绳开锁  5：短信开锁  6：区域触发)|
|dateTime |String|时间（UTC时间）|
|longitude |Double|经度(WGS-84)|
|latitude |Double|纬度(WGS-84)|
|speed |Integer|速度(km/h)|
|mileage |Long|里程(km)|
|cells |String|小区码数据，以 MNC，MCC,LAC,CID的格式显示|
|card |String|刷卡开锁卡号,仅对锁类产品有效|
|password |String|开锁密码,仅对锁类产品有效|
|describe |String|描述信息， 针对运单事件13-18事件，该描述会有Json字符串的值，展示运单唯一标识（waybillGUID）和运单号（waybillNo）信息|

##### 事件类型说明：

|事件类型|事件名称|
|:----   |-----   |
|1|开锁|
|2|关锁|
|3|出区域施封|
|4|进区域解封|
|5|开箱/门|
|6|关箱/门|
|7|蓝牙施封|
|8|蓝牙解封|
|9|远程施封|
|10|远程解封|
|11|抓拍|
|12|定时拍|
|13|离开起点|
|14|到达目的地|
|15|离开目的地|
|16|完成运单|
|17|进入途经点|
|18|离开途经点|
|19|拔出锁绳/按下开锁按键(JT705A/JT705C)|

  #### 4.指令应答数据
    设备产生的指令应答数据，包括设备号，指令类型，时间，指令返回内容信息
  ##### 推送JSON示例
    {"assetId":"742207000010","commandType":"BASE2","content":"[\"742207000010\",\"8\",\"001\",\"BASE\",\"2\",\"20220901081402\"]","dateTime":"2022-09-01T08:14:03.564Z"}
  ##### Json字段说明
  |参数名|类型|说明|
|:-----  |:-----|-----|
|assetId |String|设备号|
|commandType |String|指令类型|
|content |String|指令返回内容|
|dateTime |String|时间（UTC时间）|

#### 5.从机数据
    从机数据包括从机设备的定位数据，包括主锁/设备号，主锁/从机定位时间，经纬度，速度，里程等信息
  ##### JSON字符串示例
        {"assetId":"8012600005","longitude":113.92294,"latitude":22.670017,"speed":0,"direction":0,"gpsTime":"2023-12-07T08:30:31Z","recvTime":"2023-12-07T08:30:52.474Z","subGpsTime":"2023-12-07T08:29:50Z","battery":71,"voltage":"3.93","subAssetID":"E0171E0365","sensorType":4,"statusJson":"{\"lockRope\":0,\"gateway\":0}","locStatus":0,"locRope":0,"rssi":57,"temperature":-1000.0,"humidity":0,"eventType":6,"locTimes":5,"subGpsTimestamp":1701937790000}

##### Json字段说明
  |参数名|类型|说明|
|:-----  |:-----|-----|
|assetId |String|主锁设备号|
|longitude |Double|经度(WGS-84)|
|latitude |Double|纬度(WGS-84)|
|speed |Integer|速度(km/h)|
|direction |Integer|方向(0~360)|
|mileage |Long|里程(km)|
|gpsTime |String|主锁定位时间（UTC时间）|
|recvTime |String|主锁接收时间（UTC时间）|
|subAssetID |String|从机设备号|
|subGpsTime |String|从机定位时间（UTC时间）|
|subGpsTimestamp |long|从机定位时间时间戳|
|battery |Integer|从机电量，255表示充电中 |
|voltage |String|从机电压 (V)|
|sensorType |Integer|从机类型  1-JT126 , 4-JT709 , 5-JT801 , 6-JT802 |
|locStatus |Integer|从机锁状态  0:关  1:开 |
|locRope |Integer|从机锁绳状态  0:插入 1: 拔出  |
|rssi |Integer|RSSI |
|humidity |Integer|从机湿度 0表示无 |
|temperature |double|从机温度 -1000表示无 |
|locTimes |Integer|从机开锁次数 |
|eventType |Integer|从机事件 -1:无 0:关锁事件 1:蓝牙开锁事件 2:开后盖报警 3:远程开锁事件 4:锁绳剪断报警 5:按键唤醒事件 6:心跳包事件 7：充电唤醒事件 8/20:拔出锁绳事件 9：RFID开锁事件  10：刷非法卡报警  14：从机信号丢失报警 15：阀门关闭事件 16：阀门打开事件 17：低电量报警 18：防拆卸报警 19：电子仓拆卸事件 21：锁绳插入 22：蓝牙连接唤醒 23：应急仓打开报警 24：应急仓关闭报警 25：阀门异常打开报警 26：锁销关闭事件 27：锁销开启事件 28:关锁异常 29:电机异常  30:NFC触发 |
|statusJson |String|针对802设备的状态数据（Json字符串），其它类型设备数据可忽略（可参考下面的状态JSON说明）|

##### statusJson字段说明
"FStatusJson":"{\"bottomDisassembly\":0,\"emergencyKey\":0,\"lockMotor\":0,\"structuralDisassembly\":0,\"gateway\":0,\"lockValve\":0}"

|参数名|类型|说明|
|:-----  |:-----|-----|
|bottomDisassembly |Integer|结构防拆卸状态,0:无拆卸，1拆卸|
|emergencyKey |Integer|应急钥匙状态 0：封存，1：启用|
|lockMotor |电机状态：0：电机关，1：电机开|
|structuralDisassembly |Integer|结构防拆卸状态,0:无拆卸，1拆卸|
|lockValve |Integer|阀门状态,0:关闭，1打开|
|lockKnob |Integer|旋钮状态，0：关闭，1：打开|
|lockRope |Integer|锁绳状态 0：插入；1：拔出|
|gateway |Integer|无意义，可忽略|
 
### 推送日志报表
   用户配置好推送规则后，可以在推送日志中查询平台主动推送产生的日志，方便后续查看推送记录，对异常问题进行分析
 ![](/uploads/d3R59U60qgOHqXSG/images/m_506003f03fa220b4c3cb3b8bf4c54464_r.png)